#
/*
 *
 *	UNIX debugger
 *
 */

/*
 * Hans		Mar 10, 1983	M000
 *	- some segmentation stuff
 *	- some translation to C
 */

#include "defs.h"


MSG		ODDADR;
MSG		BADDAT;
MSG		BADTXT;
MAP		txtmap;
MAP		datmap;
INT		wtflag;
STRING		errflg;
INT		errno;

INT		pid;




/* file handling and access routines */

put(adr,space,value)
L_INT	adr;
{
	access(WT,adr,space,value);
}


/*      This routine will simplify the hacks in setting and clearing
/*      breakpoints, also be useful in changing memory, when
/*      it is made to work.  It dosent look to see which half it
/*      wants to change, and is otherwise flakey
/*putb(adr,space,value)
/*L_INT	adr;
/*{
/*	/* this is disgusting.  in order to make the minimal change to
/*	   access, we read the word we are about to write to to get
/*	   the other byte, and or it in with the new one.  It would
/*	   really be better to have all access be passed a two word
/*	   thing, but this is by far the simpler change. */
/*	INT w;
/*	w = (access(RD,adr,space,&w)&(255<<8)) | (&value&255);
/*	access(WT,adr,space,&w);
/*}     */

POS	get(adr, space)
L_INT		adr;
{
#ifdef DEBUG
	printf ("get: addr=%X, space=%d\n",adr, space);
#endif
	return(access(RD,adr,space,0));
}

POS     getb(adr, space)
L_INT		adr;
{
	return(get(adr,space)&255);
}


POS	chkget(n, space)
L_INT		n;
{
	REG INT		w;

	w = get(n, space);
	chkerr();
	return(w);
}

POS     chkgetb(n, space)
L_INT		n;
{
	REG INT		w;

	w = getb(n, space);
	chkerr();
	return(w);
}


access(mode,adr,space,value)
    register int space;
    L_INT   adr;
{
	INT             w, pmode, rd, file;
	rd = mode==RD;

	IF space == NSP THEN return(0); FI

	if(pid)		/* tracing on? */
	{
		pmode = (space&DSP?(rd?RDUSER:WDUSER):(rd?RIUSER:WIUSER));
#ifdef SEGSYM
		w = xptrace(pmode, pid, adr, value);		/*M000*/
#else
		w = ptrace(pmode, pid, shorten(adr), value);
#endif
		if(errno)
			errflg = (space&DSP ? BADDAT : BADTXT);
		return(w);
	}
	w = 0;
	if(mode==WT && wtflag==0)
		error("not in write mode");
	if(!chkmap(&adr,space))
		return(0);
	file=(space&DSP?datmap.ufd:txtmap.ufd);
	if((longseek(file,adr)==0) ||
	   (rd ? read(file,&w,2) : write(file,&value,2)) < 1)
		errflg=(space&DSP?BADDAT:BADTXT);
	return(w);

}

chkmap(adr,space)
	REG L_INT	*adr;
	REG INT		space;
{
	REG MAPPTR amap;
	amap=((space&DSP?&datmap:&txtmap));
	IF space&STAR ORF !within(*adr,amap->b1,amap->e1)
	THEN IF within(*adr,amap->b2,amap->e2)
	     THEN *adr += (amap->f2)-(amap->b2);
	     ELSE errflg=(space&DSP?BADDAT:BADTXT); return(0);
	     FI
	ELSE *adr += (amap->f1)-(amap->b1);
	FI
	return(1);
}

within(adr,lbd,ubd)
L_INT	adr, lbd, ubd;
{
#ifdef DEBUG
	printf ("is %D(%x%x) within %D(%x%x) and %D(%x%x)?\n", adr,adr,lbd, lbd,ubd, ubd);
#endif
	return(adr>=lbd && adr<ubd);
}
