#
/*
 *
 *	UNIX debugger
 *
 */

/*
 * Hans	Mar 10 1983		M000
 *	added hex format
 */

#include "defs.h"


MSG		BADSYM;
MSG		BADVAR;
MSG		BADKET;
MSG		BADSYN;
MSG		NOCFN;
MSG		NOADR;
MSG		BADLOC;

SYMTAB		symbol;
INT		lastframe;
INT		savlastf;
L_INT		savframe;
INT		savpc;
INT		callpc;



CHAR		*lp;
INT		octal;
INT		hex;			/*M000*/
STRING		errflg;
L_INT		localval;
CHAR		isymbol[8];

CHAR		lastc;
POS		*endhdr;

L_INT		dot;
L_INT		ditto;
INT		dotinc;
L_INT		var[];
L_INT		expv;




expr(a)
{	/* term | term dyadic expr |  */
	INT		rc;
	L_INT		lhs;

	rdc(); lp--; rc=term(a);

	while(rc)
	{
		lhs = expv;

		switch (readchar()) {

		    case '+':
			term(a|1); expv += lhs; break;

		    case '-':
			term(a|1); expv = lhs - expv; break;

		    case '#':
			term(a|1); expv = round(lhs,expv); break;

		    case '*':
			term(a|1); expv *= lhs; break;

		    case '%':
			term(a|1); expv = lhs/expv; break;

		    case '&':
			term(a|1); expv &= lhs; break;

		    case '|':
			term(a|1); expv |= lhs; break;

		    case ')':
			if((a&2)==0)
				error(BADKET);

		    default:
			lp--;
			return(rc);
		}
	}
	return(rc);
}

term(a)
{	/* item | monadic item | (expr) | */

	switch (readchar()) {

		    case '*':
			term(a|1); expv=chkget(expv,DSP); return(1);

		    case '@':
			term(a|1); expv=chkget(expv,ISP); return(1);

		    case '-':
			term(a|1); expv = -expv; return(1);

		    case '~':
			term(a|1); expv = ~expv; return(1);

		    case '(':
			expr(2);
			if(*lp!=')')
				error(BADSYN);
			else
				lp++; return(1);

		    default:
			lp--;
			return(item(a));
	}
}

long nval();

item(a)
{
	/* name [ . local ] | number | . | ^ | <var | <register | 'x | | */
	INT             base, d, frpt;
	unsigned int    *regptr, getreg();
	CHAR		savc;
	BOOL		lhex;
	L_INT		frame;
	UNION{REAL r; L_INT i;} real;
	SYMPTR		symp;

	lhex=FALSE;

	readchar();
	if(symchar(0))
	{
		readsym();
		/* this stuff deals with local variables. */
		if(lastc=='.')
		{
			frame=bp&EVEN;
			lastframe=0;
			callpc=pc;
			while(errflg==0)
			{
			    savpc=callpc;
			    findroutine(frame);
			    if(eqsym(symbol.symc,isymbol,'~'))
				    break;
			    lastframe=frame;
			    frame=get(frame,DSP)&EVEN;
			    if(frame==0)
				    error(NOCFN);
			}
			savlastf=lastframe; savframe=frame;
			readchar();
			if(symchar(0))
				chkloc(expv=frame);
		}
		else
		{
			symp=lookupsym(isymbol);
			if (!symp)		/*M000*/
			{
				if(hex && hexdigit(isymbol[0]))
					expv = nval();
				else
					error(BADSYM);
			}
			else
				expv = symp->symv;
		}
		lp--;

	}
	else if ((hex&&hexdigit(lastc)) || digit(lastc) ||
		 (lhex=TRUE, lastc=='#' && hexdigit(readchar())))
	{
		expv = 0;
		/*M000*/
		base = (lastc == '0' || octal ? 8 : ((hex || lhex) ? 16 : 10));
		lhex = base == 16;
		while(lhex ? hexdigit(lastc) : digit(lastc))
		{
			expv *= base;
			if((d=convdig(lastc))>=base)
				error(BADSYN);
			expv += d;
			readchar();
			if(expv==0 && (lastc|040)=='x')
		    	{
				lhex=TRUE;
				base=16;
				readchar();
			}
			else if(expv==0 &&
				((lastc|040)=='t' || (lastc|040)=='d'))
		    	{
				lhex=FALSE;
				base=10;
				readchar();
			}
		}
#ifdef HAVEFP
		if(lastc=='.' && (base==10 || expv==0) && !lhex)
		{
			real.r=expv;
			frpt=0;
			base=10;
			while(digit(readchar()))
			{
				real.r *= base;
				frpt++;
				real.r += lastc-'0';
			}
			while(frpt--)
				real.r /= base;
			expv = real.i;
		}
#endif
		lp--;
	}
	else if(lastc=='.')
	{
		readchar();
		if(symchar(0))
		{
			lastframe=savlastf;
			callpc=savpc;
			findroutine(savframe);
			chkloc(savframe);
		}
		else
			expv=dot;
		lp--;
	}

	else if(lastc=='"')
		expv=ditto;

	else if(lastc=='+')
		expv=inkdot(dotinc);

	else if(lastc=='^')
		expv=inkdot(-dotinc);

	else if(lastc=='<')
	{
		savc=rdc();
		if(regptr=getreg(savc))
			expv = *regptr;
		else if((base=varchk(savc)) != -1)
			expv=var[base];
		else	error(BADVAR);
	}

	else if(lastc=='\'')
	{
		d=4;
		expv=0;
		while(quotchar())
		{
			if(d--)
			{
				if(d==1)
					expv <<= 16;
				expv |= ((d&1)?lastc:lastc<<8);
			}
			else
				error(BADSYN);
		}

	}
	else if (a)
		error(NOADR);
	else
	{
		lp--;
		return(0);
	}
	return(1);
}

/* service routines for expression reading */

/* M000 */
long
nval()
{
	long val;
	int i,d;
	val = 0;
	for(i=0;i<8;i++)
		if (isymbol[i])
		{
			if ((d = convdigit(isymbol[i])) >=16) error(BADSYM);
			val = val * 16 + d;
		}
		else break;
	return(val);
}

readsym()
{
	REG CHAR	*p;

	p = isymbol;
	do {
		if(p < &isymbol[8])
			*p++ = lastc;
	    readchar();
	}
	while(symchar(1));
	while(p < &isymbol[8])
		*p++ = 0;
}

SYMPTR	lookupsym(symstr)
STRING	symstr;
{
	SYMPTR		symp;
	symset();
	while((symp=symget(0)))
	{
		if(((symp->symf&SYMCHK)==symp->symf)
		   && eqsym(symp->symc, symstr,'_'))
			return(symp);
	}
	return(0);
}

/* also allow upper case letters M000 */
hexdigit(c)
register CHAR c;
{
	return((c>='0' && c<='9') || ((c|=040)>='a' && c<='f'));
}

convdig(c)
CHAR c;
{
	if(digit(c))
		return(c-'0');
	else if(hexdigit(c))
		return(c-'a'+10);
	else	return(17);
}

digit(c)
char c;
{
	return(c>='0' && c<='9');
}

letter(c)
char c;
{
	return(c>='a' && c<='z' || c>='A' && c<='Z');
}

symchar(dig)
{
	if(lastc=='\\')
	{
		readchar();
		return(TRUE);
	}
	return( letter(lastc) || lastc=='_' || dig && digit(lastc) );
}

varchk(name)
{
	if(digit(name))
		return(name-'0');
	if(letter(name))
		return((name&037)-1+10);
	return(-1);
}

chkloc(frame)
L_INT		frame;
{
	readsym();
	do {
		if(localsym(frame)==0)
			error(BADLOC);
		expv=localval;
	}
	while (!eqsym(symbol.symc,isymbol,'~'));
}

eqsym(s1, s2, c)
REG STRING	s1, s2;
CHAR		c;
{
	if(eqstr(s1,s2))
		return(TRUE);
	else if (*s1==c)
	{
		CHAR		s3[8];
		REG INT		i;

		s3[0]=c;
		for(i=1; i<8; i++)
			s3[i] = *s2++;

		return(eqstr(s1,s3));
	}
	return(FALSE);
}
